/*
*/
//#include <stdio.h>
#include <stream.h>
#include <string.h>
#include <stdio.h>
//#include <g++/Integer.h>
#include <stdlib.h>

#include "xvm.h"
#include "xvmconfig.h"
#include "regclass.h"
#include "commclass.h"

#include "execclass.cpp"

#define XVM_VER_XVM "0.3.7"

Xvm::Xvm(){
  RegList=0;
  CommList=0;
  RegListLen=100;
  CommListLen=200;
  
  InitVM(RegListLen,CommListLen);
  InitProg(1);
};

Xvm::Xvm(int regs,int comms){
  RegList=0;
  CommList=0;
  RegListLen=regs;
  CommListLen=comms;
  
  InitVM(RegListLen,CommListLen);
  InitProg(1);
};

Xvm::~Xvm(){
  delete RegList;
  delete CommList;
};

int 
Xvm::InitVM(int regs,int comms){
	//int temp;
	if(RegList!=0)
		delete RegList;
	RegList= new RegListClass(regs);
	if(CommList!=0)
		delete CommList;
	CommList=new CommListClass(comms);
	return 1;
};

int 
Xvm::InitProg(int comm)
  {
    int temp;
    commhead=commcashhead;
    reghead=regcashhead;
    sorted=XVM_MAX_CASHACCES;
    SetCurCommNo(comm);
    SetPrevCommNo(comm);
    SetProgStatus(XVM_EXECUTING);
    Error=XVM_ERRM_NOERR;
    ErrorType=XVM_ERRT_NOERR;
    RegMode=XVM_REGM_DIG;
    CashMode=XVM_CASH;
    for(temp=0;temp<MAX_XVM_CASHCOMM;temp++)
      {
	CashComm[temp].busy=FALSE;
	*(commhead+temp)=-1;
	CashComm[temp].acces=0;
      };
    LastCash=PrevRegCash=0;
    for(temp=0;temp<MAX_XVM_CASHREG;temp++)
      {
	CashReg[temp].busy=FALSE;
	*(reghead+temp)=-1;
	CashReg[temp].acces=0;
      };
    LastRegCashh=0;
    DArg1=0;
    DArg2=0;
    DArg3=0;
    acces=0;
    return 1;
  };

int 
Xvm::SetProgStatus(int status){
  ProgStatus=status;
  return 1;
};

int 
Xvm::GetCurCommNo(){
return CurCommNo;
};

void 
Xvm::SetCurCommNo(int no){
	PrevCommNo=CurCommNo;
	CurCommNo=no;
};

int 
Xvm::GetPrevCommNo(){
	return PrevCommNo;
};

void
Xvm::SetPrevCommNo(int no){
	PrevCommNo=no;
};

int 
Xvm::GetErrorType(){
  return ErrorType;
};

char*
Xvm::GetError(){
return Error;
};

char*
Xvm::GetVersion(){
	return XVM_VER_XVM;
};

char* 
Xvm::GetAbout(){
	static char ab[MAX_XVM_COMMENT_LEN];
	char *rrr;
	rrr=ab;
	strcpy(rrr,"XVM Library, ver: ");
	strcat(rrr,GetVersion());
	strcat(rrr," . Copyright(c) 1998, 1999 Dmitry Morozhnikov.\n");
	return rrr;
};

int
Xvm::SetReg(int reg,char* val){
	RegList->SetVal(reg,val);
	return 1;
};

void
Xvm::SetNCDReg(int reg,long val){
	RegList->SetDVal(reg,val);
};

void
Xvm::SetDReg(int reg,long val)
  {
    register int temp;
    bool temp2;
    temp=0;
    temp2=FALSE;
    while(temp<MAX_XVM_CASHREG)
      {
        if(*(reghead+temp)==reg)
	  {
	    CashReg[temp].reg=val;
	    CashReg[temp].acces++;
	    temp=MAX_XVM_CASHREG;
	    temp2=TRUE;
	  }
	else
	  {
	    temp++;
	  };
      };
    if(temp2==FALSE && CashReg[LastRegCashh].busy==TRUE)
      {
	RegList->SetDVal(*(reghead+LastRegCashh),CashReg[LastRegCashh].reg);
      };
    if(temp2==FALSE)
      {
	*(reghead+LastRegCashh)=reg;
	CashReg[LastRegCashh].reg=val;
	CashReg[LastRegCashh].busy=TRUE;
	CashReg[LastRegCashh].acces=0;	
	if(LastRegCashh==MAX_XVM_CASHREG-1)
          {
	    LastRegCashh=0;
	  }
        else
	  {
	    LastRegCashh++;
          };
      };
  };

char*
Xvm::GetReg(int reg){
	return RegList->GetVal(reg);
};

long 
Xvm::GetDReg(int reg)
  {
    register int temp;
    temp=0;
    while(temp<MAX_XVM_CASHREG)
      {
	if(*(reghead+temp)==reg)
	  {
	    CashReg[temp].acces++;
	    return CashReg[temp].reg;
	  }
	else
	  {
	    temp++;
	  };
      };
    if(CashReg[LastRegCashh].busy==TRUE)
      {
	RegList->SetDVal(*(reghead+LastRegCashh),CashReg[LastRegCashh].reg);
      };
    *(reghead+LastRegCashh)=reg;
    CashReg[LastRegCashh].busy=TRUE;
    CashReg[LastRegCashh].acces=0;
    temp=CashReg[LastRegCashh].reg=RegList->GetDVal(reg);
    if(LastRegCashh==MAX_XVM_CASHREG-1)
      {
	LastRegCashh=0;
      }
    else
      {
	LastRegCashh++;
      };
    return temp;
  };

int 
Xvm::SetComm(int comm,char* stat){
	CommList->SetVal(comm,stat);
	return 1;
};

int 
Xvm::SetComment(int comm,char* comment){
	CommList->SetComm(comm,comment);
	return 1;
};

char*
Xvm::GetComment(int comm){
	return CommList->GetComm(comm);
};

void
Xvm::StepProg()
  {
    Jump=0;
    acces++;
    if(acces==sorted)
      {
	SortCash();
      };
    VerifyComm();
    DProcessComm();
    if(Jump==0 && ProgStatus==XVM_EXECUTING)
      {
	SetCurCommNo(CurCommNo+1);
      }
    else
      {
	if(ProgStatus==XVM_EXECUTING)
	  {
		SetCurCommNo(Jump);
	  };
      };
  };

int 
Xvm::StopProg(int err)
  {
    SetProgStatus(err);
    CashMode=XVM_NOCASH;
    LastCash=0;
    LastRegCashh=PrevRegCash=acces=0;
    if(err!=XVM_EXECUTING)
      {
        SyncRegs();
      };
    return 1;
  };

int 
Xvm::SyncRegs()
  {
    int temp;
    for(temp=0;temp<MAX_XVM_CASHREG;temp++)
      {
        if(CashReg[temp].busy==TRUE)
          {
	    RegList->SetDVal(*(reghead+temp),CashReg[temp].reg);
	    CashReg[temp].busy=FALSE;
	    *(reghead+temp)=-1;
	    CashReg[temp].acces=0;
	  };
      };
    if(RegMode==XVM_REGM_DIG)
      {
    	RegList->SyncVals(REGCL_TO_CHAR);
      }
    else
      {
    	RegList->SyncVals(REGCL_TO_DIG);
      };
    return 1;
  };

void 
Xvm::SortCash()
  {
    register int temp;
    static xvmcommcash ccash;
    static xvmregcash rcash;
    static int temp2;
    static int modified;
    acces=0;
    modified=0;
    for(temp=MAX_XVM_CASHCOMM-1;temp>0;temp--)
      {
        if(CashComm[temp].acces>CashComm[temp-1].acces)
          {
	    temp2=*(commhead+temp);
	    *(commhead+temp)=*(commhead+temp-1);
	    *(commhead+temp-1)=temp2;
	    //ccash.no=CashComm[temp].no;
    	    ccash.type=CashComm[temp].type;
	    ccash.arg1=CashComm[temp].arg1;
	    ccash.arg2=CashComm[temp].arg2;
	    ccash.arg3=CashComm[temp].arg3;
	    ccash.busy=CashComm[temp].busy;
	    ccash.acces=CashComm[temp].acces;
    	    //CashComm[temp].no=CashComm[temp-1].no;
	    CashComm[temp].type=CashComm[temp-1].type;
    	    CashComm[temp].arg1=CashComm[temp-1].arg1;
	    CashComm[temp].arg2=CashComm[temp-1].arg2;
    	    CashComm[temp].arg3=CashComm[temp-1].arg3;
	    CashComm[temp].busy=CashComm[temp-1].busy;
	    CashComm[temp].acces=CashComm[temp-1].acces;
	    //CashComm[temp-1].no=ccash.no;
	    CashComm[temp-1].type=ccash.type;
	    CashComm[temp-1].arg1=ccash.arg1;
    	    CashComm[temp-1].arg2=ccash.arg2;
	    CashComm[temp-1].arg3=ccash.arg3;
	    CashComm[temp-1].busy=ccash.busy;
	    CashComm[temp-1].acces=ccash.acces;
	    modified++;
	  };
	CashComm[temp].acces=0;
      };
    for(temp=MAX_XVM_CASHREG-1;temp>0;temp--)
      {
        if(CashReg[temp].acces>CashReg[temp-1].acces)
          {
	    temp2=*(reghead+temp);
	    *(reghead+temp)=*(reghead+temp-1);
	    *(reghead+temp-1)=temp2;
	    //rcash.no=CashReg[temp].no;
    	    rcash.reg=CashReg[temp].reg;
	    rcash.busy=CashReg[temp].busy;
	    rcash.acces=CashReg[temp].acces;
	    //CashReg[temp].no=CashReg[temp-1].no;
    	    CashReg[temp].reg=CashReg[temp-1].reg;
	    CashReg[temp].busy=CashReg[temp-1].busy;
	    CashReg[temp].acces=CashReg[temp-1].acces;
	    //CashReg[temp-1].no=rcash.no;
	    CashReg[temp-1].reg=rcash.reg;
	    CashReg[temp-1].busy=rcash.busy;
	    CashReg[temp-1].acces=rcash.acces;
	    modified++;
	  };
	CashReg[temp].acces=0;
      };
    CashReg[0].acces=0;
    CashComm[0].acces=0;
    if(modified<3)
      {
	sorted+=sorted;
      };
  };
